.\" $NetBSD: cpu_reboot.9,v 1.16 2003/04/16 13:35:27 wiz Exp $
.\"
.\" Copyright (c) 1994 Christopher G. Demetriou
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"          This product includes software developed for the
.\"          NetBSD Project.  See http://www.NetBSD.org/ for
.\"          information about NetBSD.
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" <<Id: LICENSE,v 1.2 2000/06/14 15:57:33 cgd Exp>>
.\"
.Dd September 4, 2009
.Dt CPU_REBOOT 9
.Os
.Sh NAME
.Nm cpu_reboot
.Nd halt or reboot the system
.Sh SYNOPSIS
.In sys/reboot.h
.Ft void
.Fn cpu_reboot "int howto" "char *bootstr"
.Sh DESCRIPTION
The
.Fn cpu_reboot
function handles final system shutdown, and either halts or reboots
the system.
The exact action to be taken is determined by the flags passed in
.Fa howto
and by whether or not the system has finished autoconfiguration.
.Pp
If the system has finished autoconfiguration,
.Fn cpu_reboot
does the following:
.Bl -enum -offset indent
.It
Sets the
.Va boothowto
system variable (see
.Xr boothowto 9 )
from the
.Fa howto
argument.
.It
If this is the first invocation of
.Fn cpu_reboot
and the
.Dv RB_NOSYNC
flag is not set in
.Fa howto ,
syncs and unmounts the system disks by calling
.Xr vfs_shutdown 9
and sets the time of day clock by calling
.Xr resettodr 9 .
.It
Disables interrupts.
.It
If rebooting after a crash (i.e., if
.Dv RB_DUMP
is set in
.Fa howto ,
but
.Dv RB_HALT
is not), saves a system crash dump.
.It
Runs any shutdown hooks by calling
.Xr doshutdownhooks 9 .
.It
Prints a message indicating that the system is about to be halted
or rebooted.
.It
If
.Dv RB_HALT
is set in
.Fa howto ,
halts the system.
Otherwise, reboots the system.
.El
.Pp
If the system has not finished autoconfiguration,
.Fn cpu_reboot
runs any shutdown hooks by calling
.Xr doshutdownhooks 9 ,
prints a message, and halts the system.
.Pp
If
.Dv RB_STRING
is set in
.Pa howto ,
then the parameter
.Fa bootstr
is passed to the system boot loader on some ports.
.Sh SEE ALSO
.Xr boothowto 9 ,
.Xr doshutdownhooks 9 ,
.Xr dumpsys 9 ,
.Xr resettodr 9 ,
.Xr vfs_shutdown 9
